// MechInfTac_init.sqf
// 2010 - Sirex
// If you want to only activate the script for certain IFV/Vehicles then set MechInfTac_Init_AlwaysCheckForNewIFV in init to false and 
// go to the line "//COMMENT AWAY THIS NEXT BLOCK TO REMOVE AUTOMATIC VEHICLE CHECK ON THE MAP START" and comment away the next block. Also decomment the line above.
// Then you send in your own vehilce in a variable named _ifvArray in the form of _ifvArray=[Vehicel object 1, Vehilce object 2, ...];


private ["_AllWest","_AllEast","_AllRes","_s","_currentIfv","_ifvInfantryArray","_loop","_noCargoIsAssigned","_infantrySoldier","_infantryIsAlive","_enemyUnit","_ignoreEnemy","_IsEnemyUnitAlive","_IsEnemyUnitSpotted","_IsEnemyUnitWithinEngagmentRange","_noNearbyDetectedEnemies","_IsUnitInCurrentFormation","_IsUnitCrew","_isIfvEngaging","_isTargetDead","_contact","_newIfv","_hasInfantry","_IsFollowedSoldierDead","_IsInfantryAlive"];
private ["_trg1","_trg2","_currentSoldier"];
if (!isServer) exitWith {};

_ifvInfantryArray=[]; //Holds all infantry connected to an ifv.

//checkRadioCommands =
//{
    _trg1 = createTrigger["EmptyDetector",getPos player];
    _trg1 setTriggerArea[0,0,0,false];
    _trg1 setTriggerActivation["ALPHA","",true];
    _trg1 setTriggerText "Lock vehicle"; // title for the radio option.
    _trg1 setTriggerStatements["this", "call setWaypointForVehicle", ""];   
    
    _trg2 = createTrigger["EmptyDetector",getPos player];
    _trg2 setTriggerArea[0,0,0,false];
    _trg2 setTriggerActivation["BRAVO","",true];
    _trg2 setTriggerText "Unlock vehicle"; // title for the radio option.
    _trg2 setTriggerStatements["this", "(_ifvArray select _currentIfv)  setVariable [""_ignoreEnemy"",""false"",true]",""];    
    
//};
    // Set waypoint to current waypoint for the vehilce
    setWaypointForVehicle = 
    {
       // hint "set waypoint!";
        MechInfTac_LockCargo = "true";
        
        (_ifvArray select _currentIfv)  setVariable ["_ignoreEnemy","true",true];
        _waypointValueIsLessThenCurrentWaypoint = (currentWaypoint (group (_ifvArray select _currentIfv))) > (_ifvArray select _currentIfv getVariable "_waypoint");
        if( _waypointValueIsLessThenCurrentWaypoint ) then
        {
         //   hint "set waypoint!2";
            _ifvArray select _currentIfv setVariable ["_waypoint",(currentWaypoint (group (_ifvArray select _currentIfv)))];
        };
    };
    

mountup =
{
    
             (_ifvInfantryArray select _currentIfv) allowGetIn true;
             {
                 _x setBehaviour "aware";
             } forEach (_ifvInfantryArray select _currentIfv);
             // If _ifvStayPut is true stop the ifv from moving
             if( _ifvArray select _currentIfv getVariable "_ifvStayPut" == "true" )then
             {
                 //hintSilent "ifv movement activated";
                 (_ifvArray select _currentIfv) forceSpeed -1;	
            };
            
          //  doStop (_ifvArray select _currentIfv);
            (_ifvInfantryArray select _currentIfv) orderGetIn true;   
           // commandGetOut (_ifvInfantryArray select _currentIfv);															

};

dismount = 
{
             // Stops IFV and dismount infantry
             //doStop (_ifvArray select _currentIfv); 
            // If _ifvStayPut is true stop the ifv from moving
            if( _ifvArray select _currentIfv getVariable "_ifvStayPut" == "true" )then
            {
               // hintSilent "ifv movement stopped";
                (_ifvArray select _currentIfv) forceSpeed 0;
            };
                   
            _ifvArray select _currentIfv setBehaviour "combat";
            (_ifvInfantryArray select _currentIfv) allowGetIn false;
            sleep 1;	
            //doGetOut (_ifvInfantryArray select _currentIfv);
           
            (_ifvInfantryArray select _currentIfv) orderGetIn false;
            /*
            {						
                _x setBehaviour "combat";
            } forEach (_ifvInfantryArray select _currentIfv);
            */
            
            if( (_this select 2) == "true") then
            {
           //     hintSilent "stay!";  
           //     _currentGroup = (group _currentSoldier);
           //     _currentSoldier = ((_ifvInfantryArray select _currentIfv) select (_ifvArray select _currentIfv getVariable "_followedSoldier"));
           //     _currentWaypoint = currentWaypoint (group (_ifvArray select _currentIfv));
           //     _wp =  _currentGroup addWaypoint [position _currentSoldier, currentWaypoint (group (_ifvArray select _currentIfv))];
           //     _wp setWaypointType "HOLD";
           //     (group _currentSoldier) setCurrentWaypoint [ _currentGroup , _currentWaypoint ];                
            } else 
            {
                // The infantry moves to target
                (group (_ifvArray select _currentIfv)) move position (_ifvArray select _currentIfv getVariable "_target"); 
            };
   
     //      {
     //          _x setFormation "LINE";
	//		} forEach (_ifvInfantryArray select _currentIfv);
            
            // Set the IFV to follow the infantry.
            if( _ifvArray select _currentIfv getVariable "_ifvStayPut" == "false" )then
            {
               // hintSilent "Command follow";
                (_ifvArray select _currentIfv) doFollow ((_ifvInfantryArray select _currentIfv) select (_ifvArray select _currentIfv getVariable "_followedSoldier"));	
            };
};

_AllWest=[];
_AllEast=[];
_AllRes=[];

// find all units in mission
{
    _s = side _x;
    switch (_s) do 
    {
        case west: 
        { _AllWest=_AllWest+[_x]; };
        case east: 
        { _AllEast=_AllEast+[_x]; };
        case resistance: 
        { _AllRes=_AllRes+[_x]; };
    };
}forEach allUnits;

_ifvArray=[];

// diag_log _ifvArrayPassed;
// Find all IFV
// Decomment next line to enable pass vehicles to the script
// _ifvArray = _this select 3;
// COMMENT AWAY THIS NEXT BLOCK TO REMOVE AUTOMATIC VEHICLE CHECK ON THE MAP START

{
    if(!(assignedVehicle _x in _ifvArray) ) then
    {
        // hint "start";
        _ifvArray=_ifvArray+[assignedVehicle _x];
    };		
} forEach allUnits; 




// Clear out ifv in the _ifvArray with no infantry
for [ {_newIfv = ((count _ifvArray)-1) }, { _newIfv >(-1) }, { _newIfv = _newIfv - 1 }] do 
{
    _hasInfantry = false;
    _noCargoIsAssigned = (count assignedCargo(_ifvArray select _newIfv))==0;	
    if(_noCargoIsAssigned) then
    {	
        {
            //Next three lines are for bug finding/cheking.
            //diag_log _x;
            //diag_log (_x in (units (_ifvArray select _newIfv)));
            //diag_log !(_x in crew (_ifvArray select _newIfv));
        
            _IsUnitInCurrentFormation = (_x in (units (_ifvArray select _newIfv)));
            _IsUnitCrew = (_x in crew (_ifvArray select _newIfv));
            if( _IsUnitInCurrentFormation and !_IsUnitCrew ) then
            {					
                _hasInfantry = true;
            };
        } forEach allUnits;
    }
    else
    {
        _hasInfantry = true;
    };
    
    if(_hasInfantry)then 
    {        
    }
    else 
    {
        _ifvArray = _ifvArray - [(_ifvArray select _newIfv)];
    };
};

// Connects infantry with IFV
for [ {_newIfv = ((count _ifvArray))-1 }, { _newIfv >(-1) }, { _newIfv = _newIfv - 1 }] do 
{
    _noCargoIsAssigned = (count assignedCargo(_ifvArray select _newIfv))==0;		
    // Code for assigning infantry to Vehicels who are not in cargo when the mission starts. 
    if(_noCargoIsAssigned) then
    {	
        {
            //Next three lines are for bug finding/cheking.
            //diag_log _x;
            //diag_log (_x in (units (_ifvArray select _newIfv)));
            //diag_log !(_x in crew (_ifvArray select _newIfv));
            _IsUnitInCurrentFormation = (_x in (units (_ifvArray select _newIfv)));
            _IsUnitCrew = (_x in crew (_ifvArray select _newIfv));
            if( _IsUnitInCurrentFormation and !_IsUnitCrew ) then
            {					
                if (  count _ifvInfantryArray < _newIfv )then
                {
                    _ifvInfantryArray set[ _newIfv, [_x]] ;
                }
                else
                {
                    _ifvInfantryArray set [_newIfv , (_ifvInfantryArray select _newIfv) + [_x]];  
                };
            };
        } forEach allUnits;
    }
    else
    {
        // Assigning infantry in Cargo to the Ifv
        _ifvInfantryArray set [_newIfv, assignedCargo (_ifvArray select _newIfv)];
    };
    
    //Assigning variables to _newIfv.
    (_ifvArray select _newIfv)  setVariable ["_contact", "false", true];		       	// Is true if enemy know of enemy within engagment range.
    (_ifvArray select _newIfv)  setVariable ["_engaging", "false", true];			// Is true if enemy is performing an attack, like dismount and engage enemy.
    (_ifvArray select _newIfv)  setVariable ["_pullout", "false", true];		       	// Not implemented.
    (_ifvArray select _newIfv)  setVariable ["_ignoreEnemy", "false", true];		// Used to force infantry to stay in cargo.
    (_ifvArray select _newIfv)  setVariable ["_waypoint", 0, true];	         	// Used to hold cargo inside until the waypoint is reached.
    (_ifvArray select _newIfv)  setVariable ["_infantryAlive","false",true];       // Is true if any connected infantry is alive
    (_ifvArray select _newIfv)  setVariable ["_target", ObjNull, true];	            // Current target, used as a move to order.
    (_ifvArray select _newIfv)  setVariable ["_followedSoldier", objNull, true];	// Which soldier the IFV will follow during an assualt. NOTE: this is the number in the array, not an object!
    (_ifvArray select _newIfv)  setVariable ["_distance", 200, true];				// Which distance the ifv should engage enemy in.
    (_ifvArray select _newIfv)  setVariable ["_ifvStayPut", _this select 1, true];				// Is true if the IFV shold stay put if infantry dismounts.
    
    // Assign an alive infantry as teh infantry the ifv should follow in engagement.
    for [{ _infantrySoldier = 0 },{ _infantrySoldier < (count (_ifvInfantryArray select _newIfv)) },{ _infantrySoldier = _infantrySoldier + 1}] do
    {
        _infantryIsAlive = alive ((_ifvInfantryArray select _newIfv) select _infantrySoldier);
        if( _infantryIsAlive ) then
        {
            _ifvArray select _newIfv setVariable ["_infantryAlive","true",true];
            _ifvArray select _newIfv setVariable ["_followedSoldier", _infantrySoldier,true];
        };		
    }; 
};

// ***********************************************************************************************************
// ************************************************ MAIN LOOP ************************************************
diag_log _ifvArray;
_loop=true; 
MechInfTac_LockCargo_LastItteration = "not intialized yet";
While {_loop} do {
    
    // Connects infantry with Ifv IF the bool value _AlwaysCheckForNewIFV is "true". Default is "false".
    if((_this select 0) == "true") then
    {
        {
            if(!(assignedVehicle _x in _ifvArray)) then
            {
                // hint "start";
                _ifvArray=_ifvArray+[assignedVehicle _x];
                _newIfv = (count _ifvArray -1);
                
                //Clear out ifv with no infantry
                _hasInfantry = false;
                _noCargoIsAssigned = (count assignedCargo(_ifvArray select _newIfv))==0;	
                if(_noCargoIsAssigned) then
                {	
                    {
                        //Next three lines are for bug finding/cheking.
                        //diag_log _x;
                        //diag_log (_x in (units (_ifvArray select _newIfv)));
                        //diag_log !(_x in crew (_ifvArray select _newIfv));
                        _IsUnitInCurrentFormation = (_x in (units (_ifvArray select _newIfv)));
                        _IsUnitCrew = (_x in crew (_ifvArray select _newIfv));
                        if( _IsUnitInCurrentFormation and !_IsUnitCrew ) then
                        {					
                            _hasInfantry = true;
                        };
                    } forEach allUnits;
                }
                else
                {
                    _hasInfantry = true;
                };
                if(_hasInfantry)then 
                {
                    
                }
                else 
                {
                    _ifvArray = _ifvArray - [(_ifvArray select _newIfv)];
                };
                
                _noCargoIsAssigned = (count assignedCargo(_ifvArray select _newIfv))==0;		
                // Code for assigning infantry to Vehicels who are not in cargo when the mission starts. 
                if(_noCargoIsAssigned) then
                {	
                    {
                        //Next three lines are for bug finding/cheking.
                        //diag_log _x;
                        //diag_log (_x in (units (_ifvArray select _newIfv)));
                        //diag_log !(_x in crew (_ifvArray select _newIfv));
                        _IsUnitInCurrentFormation = (_x in (units (_ifvArray select _newIfv)));
                        _IsUnitCrew = (_x in crew (_ifvArray select _newIfv));
                        if( _IsUnitInCurrentFormation and !_IsUnitCrew ) then
                        {					
                            if (  count _ifvInfantryArray < _newIfv )then
                            {
                                _ifvInfantryArray set[ _newIfv, [_x]] ;
                            }
                            else
                            {
                                _ifvInfantryArray set [_newIfv , (_ifvInfantryArray select _newIfv) + [_x]];  
                            };
                        };
                    } forEach allUnits;
                }
                else
                {
                    // Assigning infantry in Cargo to the Ifv
                    _ifvInfantryArray set [_newIfv, assignedCargo (_ifvArray select _newIfv)];
                };
                
                //Assigninf variables to _newIfv.
                (_ifvArray select _newIfv)  setVariable ["_contact", "false", true];			// Is true if enemy know of enemy within engagment range.
                (_ifvArray select _newIfv)  setVariable ["_engaging", "false", true];			// Is true if enemy is performing an attack, like dismount and engage enemy.
                (_ifvArray select _newIfv)  setVariable ["_pullout", "false", true];			// Not implemented.
                (_ifvArray select _newIfv)  setVariable ["_ignoreEnemy", "false", true];		// Used to force infantry to stay in cargo.
                (_ifvArray select _newIfv)  setVariable ["_waypoint", 0, true];	         	// Used to hold cargo inside until the waypoint is reached.
                (_ifvArray select _newIfv)  setVariable ["_infantryAlive","false",true];          // Is true if any connected infantry is alive
                (_ifvArray select _newIfv)  setVariable ["_target", ObjNull, true];	// Current target, used as a move to order.
                (_ifvArray select _newIfv)  setVariable ["_followedSoldier", objNull, true];	// Which soldier the IFV will follow during an assualt. NOTE: this is the number in the array, not an object!
                (_ifvArray select _newIfv)  setVariable ["_distance", 200, true];				// Which distance the ifv should engage enemy in.
                (_ifvArray select _newIfv)  setVariable ["_ifvStayPut", _this select 1, true];				// Is true if the IFV shold stay put if infantry dismounts.
                
                // Assign an alive infantry as teh infantry the ifv should follow in engagement.
                for [{ _infantrySoldier = 0 },{ _infantrySoldier < (count (_ifvInfantryArray select _newIfv)) },{ _infantrySoldier = _infantrySoldier + 1}] do
                {
                    _infantryIsAlive = alive ((_ifvInfantryArray select _newIfv) select _infantrySoldier);
                    if( _infantryIsAlive ) then
                    {
                        _ifvArray select _newIfv setVariable ["_infantryAlive","true",true];
                        _ifvArray select _newIfv setVariable ["_followedSoldier", _infantrySoldier,true];
                    };		
                }; 
            };		
        } forEach allUnits;   
    };
    
    // Loop through all Ifv.
    for [{ _currentIfv = 0 },{ _currentIfv < (count _ifvArray) },{ _currentIfv = _currentIfv + 1}] do
    {
        // Determine enemy side for current ifv.	
        _ifvArray select _currentIfv setVariable ["_enemySide",_AllEast,true];
		if((side (_ifvArray select _currentIfv)) == east) then
        {
            _ifvArray select _currentIfv setVariable["_enemySide",_AllWest,true];
        };
        
        //If no one of the _ifvArray [X] infantry is alive then set _infantryAlive to false, so that the IFV don't follow dead soldiers. 	
 		_ifvArray select _currentIfv setVariable ["_infantryAlive","false",true];
        //Check for alive soldiers bound to current ifv.
        for [{ _infantrySoldier = 0 },{ _infantrySoldier < count (_ifvInfantryArray select _currentIfv) },{ _infantrySoldier = _infantrySoldier + 1}] do
        {
            _IsInfantryAlive = alive ((_ifvInfantryArray select _currentIfv) select _infantrySoldier);
            if( _IsInfantryAlive) then
            {
                _ifvArray select _currentIfv setVariable ["_infantryAlive","true",true];
                //hint "alive";
                
                _IsFollowedSoldierDead = !alive((_ifvInfantryArray select _currentIfv) select (_ifvArray select _currentIfv getVariable "_followedSoldier"));
                if(_IsFollowedSoldierDead) then
                {
                    _ifvArray select _currentIfv setVariable ["_followedSoldier", _infantrySoldier,true];     
                     // This code is supposed to give new alive soldiers for the ifv to follow during combat, but it makes the ifv stop following infantry so the code is commented out.
                    
                   // _IsIfvEngaging = (_ifvArray select _currentIfv) getVariable "_engaging" == "true"; 
                    if( _ifvArray select _currentIfv getVariable "_contact" == "true" 
                    && _ifvArray select _currentIfv getVariable "_infantryAlive" == "true"
                    && _ifvArray select _currentIfv getVariable "_engaging" == "true"
                    && _ifvArray select _currentIfv getVariable "_ignoreEnemy" == "false") then
                    {    
                        if( _ifvArray select _currentIfv getVariable "_ifvStayPut" == "false" )then
                        {
                            //hint "following new soldier!";
                            (_ifvArray select _currentIfv) commandFollow ((_ifvInfantryArray select _currentIfv) select (_ifvArray select _currentIfv getVariable "_followedSoldier"));	
                            diag_log ((_ifvInfantryArray select _currentIfv) select (_ifvArray select _currentIfv getVariable "_followedSoldier"));
                        };
                    };
                    
                };        
                //_IsFollowedSoldierNotInCrew = !((_ifvInfantryArray select _currentIfv) select (_ifvArray select _currentIfv getVariable "_followedSoldier") in crew (_ifvArray select _currentIfv));  
                // If _followedSoldier dies during engagement, replace _followedSoldier with a soldier who is alive and follow him
            };		
        };	 
        
        //_IsIfvInfatryAlive = (_ifvArray select _currentIfv) getVariable "_infantryAlive"=="true";
        // If no infantry alive is bound to current ifv set ifv to none mech attack stance.
        //_IsifvInfatryDead = _ifvArray select _currentIfv getVariable "_infantryAlive"=="false";
        //if( _IsifvInfatryDead ) then
        //{
         //   hint "all soldiers dead";
        //    (_ifvArray select _currentIfv) forceSpeed -1;
       //     _ifvArray select _currentIfv setVariable ["_engaging","false",true];
      //      _ifvArray select _currentIfv setVariable ["_followedSoldier", 99, true];	// 99 is just to set to a none existing soldier.
     //   }; 
		
        
        (_ifvArray select _currentIfv) setVariable ["_contact","false",true];	// Contact is false unless we find a contact in the next for loop.
        //Checking for alive enemy within _distance.
        for [{ _enemyUnit = 0},{ _enemyUnit < count ( _ifvArray select _currentIfv getVariable "_enemySide")},{ _enemyUnit = _enemyUnit + 1}] do
        {	
            _ignoreEnemy = (_ifvArray select _currentIfv) getVariable "_ignoreEnemy" == "true";
            _IsEnemyUnitAlive = alive (_ifvArray select _currentIfv getVariable "_enemySide" select _enemyUnit);
            _IsEnemyUnitSpotted = not isNull(((crew (_ifvArray select _currentIfv) select 0 ) findNearestEnemy position (crew (_ifvArray select _currentIfv) select 0 )));
            _IsEnemyUnitWithinEngagmentRange = ((crew (_ifvArray select _currentIfv) select 0 ) distance ( _ifvArray select _currentIfv getVariable "_enemySide" select _enemyUnit)) <=	(_ifvArray select _currentIfv getVariable "_distance");
            
            // Checking for enemy contacts
            if ( !_ignoreEnemy 	&& _IsEnemyUnitAlive && _IsEnemyUnitSpotted	&& _IsEnemyUnitWithinEngagmentRange) then
            {		
               //  hintSilent "contact!";
                (_ifvArray select _currentIfv) setVariable ["_contact","true",true];   		
            }; 
        };
        
        // This code is supposed to give new targets during combat, but it makes the ifv stop following infantry so the code is commented out.
        /*
        _isIfvEngaging = (_ifvArray select _currentIfv) getVariable "_engaging" == "true";
        _isTargetDead = !alive(_ifvArray select _currentIfv getVariable "_target");
        _contact = ((_ifvArray select _currentIfv) getVariable "_contact" == "true");
        // If Ifv is engaging and its target dies, find a new one and attack that one.
        if ( _isIfvEngaging && _isTargetDead &&  _contact) then
        {		
           // hintSilent "New target";
            _ifvArray select _currentIfv setVariable ["_target",  ((crew (_ifvArray select _currentIfv) select 0 ) findNearestEnemy ((crew (_ifvArray select _currentIfv) select 0 ))),true];   
            (_ifvInfantryArray select _currentIfv) commandMove position (_ifvArray select _currentIfv getVariable "_target"); 
        }; 
        */
                
        // Check if the vehicle should be unlocked. Only execute if the MechInfTac_LockCargo has changed value
        if(MechInfTac_LockCargo == "false" && MechInfTac_LockCargo_LastItteration != MechInfTac_LockCargo) then
        {
            _ifvArray select _currentIfv setVariable ["_ignoreEnemy","false",true];
        };
        
        // Check if the vehicle should be locked. Only execute if the MechInfTac_LockCargo has changed value
        if(MechInfTac_LockCargo == "true" && MechInfTac_LockCargo_LastItteration != MechInfTac_LockCargo) then
        {
            call setWaypointForVehicle;
            _ifvArray select _currentIfv setVariable ["_ignoreEnemy","true",true];    
        };        
        
        // Keeps the infantry in the vehicle cargo until the next waypoint is reached
        if( _ifvArray select _currentIfv getVariable "_ignoreEnemy" == "true" ) then
        {
            _waypointIsReached = (currentWaypoint (group (_ifvArray select _currentIfv))) > (_ifvArray select _currentIfv getVariable "_waypoint");
            if( _waypointIsReached ) then
            {
                // hint "locked!";
                _ifvArray select _currentIfv setVariable ["_ignoreEnemy","false",true];
                MechInfTac_LockCargo = "false";
            }
            else
            {
                // Code to keep the infantry in the vehicle
                //  hint "get in!";
                {
                    _x moveInCargo vehicle (_ifvArray select _currentIfv);
                } forEach (_ifvInfantryArray select _currentIfv);
                (_ifvInfantryArray select _currentIfv) orderGetIn true;
            };
        };
 
        
        //Dismount and engages enemyies.
        if( _ifvArray select _currentIfv getVariable "_contact" == "true" 
        && _ifvArray select _currentIfv getVariable "_infantryAlive" == "true"
        && _ifvArray select _currentIfv getVariable "_engaging" == "false"
        && _ifvArray select _currentIfv getVariable "_ignoreEnemy" == "false") then
        {
         // hintSilent "dismount";	
            _ifvArray select _currentIfv setVariable ["_target",  ((crew (_ifvArray select _currentIfv) select 0 ) findNearestEnemy ((crew (_ifvArray select _currentIfv) select 0 ))),true];
            // Adding 20 meters to distance because otherwise if enemy moves out of range by one meter the mountupp code will kick in, so this is to give some leaway to avoid loops. 
            // This extra 20 meters is later removed in the mountupp code.
            _ifvArray select _currentIfv setVariable ["_distance",(_ifvArray select _currentIfv getVariable "_distance")+20,true]; 
            
            // Stops IFV and dismount infantry
           call dismount;
            (_ifvArray select _currentIfv) setVariable["_engaging","true",true];
        };
        
        
        //Mountupp code when no enemy is detected
        _noNearbyDetectedEnemies = isNull((crew (_ifvArray select _currentIfv) select 0 ) findNearestEnemy (crew (_ifvArray select _currentIfv) select 0 ));		
        if( _noNearbyDetectedEnemies && (_ifvArray select _currentIfv getVariable "_engaging") == "true"
        && _ifvArray select _currentIfv getVariable "_ignoreEnemy" == "false") then
        {
         // removing the extra 20 meters that was added in "Dismount and engages enemyies." code.
            _ifvArray select _currentIfv setVariable ["_distance",(_ifvArray select _currentIfv getVariable "_distance")-20,true];
         // hintSilent "Mounting up!";
            call mountup;
            _ifvArray select _currentIfv setVariable ["_engaging","false",true];
        };
        
    }; 
    MechInfTac_LockCargo_LastItteration = MechInfTac_LockCargo;
	sleep 1;
};



